#!/usr/bin/python
#tell_pony.py (C) Copyright 2007, Phil Underwood

# This file is part of PonyTrainer.

# PonyTrainer is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# PonyTraine is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with PonyTrainer; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# this program reads an input file, and sends all the commands to the pony
# any KOs are picked up and echoed to stderr
# output is transferred to stdout as a log file.
# Hello and Quit are assumed
import tty
import sys
import struct
from optparse import OptionParser

parser = OptionParser()
parser.add_option("-d", "--device", default="/dev/ttyUSB0",
                  help="device Pony connects as", metavar="FILE")
parser.add_option("-i", "--input", dest = "ifile",metavar="FILE",
                  help="input file name")
(options,args) = parser.parse_args()

pony =open(options.device,"w+",0)
tty.setraw(pony.fileno())
pony.write("Hello\n")
pony.readline()
if (pony.readline().find("OK") == -1):
    sys.stderr.write("Awww cuntflaps\n");
    exit(0)
if (options.ifile):
    ifile = open(options.ifile,"r")
else:
    ifile = sys.stdin
#print ifile
i = 0
for s in ifile.readlines():
    i = i + 1
    pony.write(s)
    templine = pony.readline()
    answer = pony.readline()
    print s.strip()
    print templine.strip()
    print answer.strip()
    if (answer.find("OK")==-1):
        sys.stderr.write("Error on Line: %d (%s)\n" % (i,s.strip()))
        sys.stderr.write("Response was:\n")
        sys.stderr.write(templine)
        sys.stderr.write(answer)
pony.write("Quit\n")
pony.readline()
pony.readline()
    
